
bool read_adc(u8 *adc_result, u8 adc_cnt=8, u8 adc_cnl=3)
{
 static bool trg;
 static u8 tmp_cnt;
 static u16 tmp;

 if(!trg)
 {
  trg =1;
  tmp_cnt = adc_cnt;
  tmp = 0;

  if(adc_cnl > 0x0f)return 1;

  ADC1->CSR = adc_cnl;

  if(ADC1->CR1 & ADC1_CR1_ADON) ADC1->CR1 |= ADC1_CR1_ADON;
  else
  {
   ADC1->CR1 |= ADC1_CR1_ADON;
   while((ADC1->CR1 & ADC1_CR1_ADON)==0) nop();
   ADC1->CR1 |= ADC1_CR1_ADON;
  }
 }

 if(ADC1->CSR & ADC1_CSR_EOC)
 {
  if(tmp_cnt)
  {
   tmp_cnt--;
   tmp += ADC1->DRH;
   ADC1->CSR = adc_cnl;
   ADC1->CR1 |= ADC1_CR1_ADON;
  }
  else
  {
   *adc_result = tmp/adc_cnt;

   trg = 0;
   return 1;
  }
 }

 return 0;
}

