#include "display_work.h"

void display_data()
{
 static u8 pc;
 u8 tmp;

 CW_GDF *pt;
 GDF *pt2;
 u8 kl;

 //   
 pt = com_wire+pc;

 for(u8 k=0;k<CW_NUM;k++)
 {
  pt2 = pt->wire + k;

  kl = (u8)pt2->GPIO_Pin;

  // 
  pt2->GPIOx->CR1 &= ~kl;
  //  
  pt2->GPIOx->DDR &= ~kl;
 }

 //  
 (pc)?(pc--):(pc = DNUM-1);

 //      
 switch (dbuf[pc])
 {
  case 0:   tmp = bin(00000010); break;
  case 1:   tmp = bin(10011110); break;
  case 2:   tmp = bin(00100100); break;
  case 3:   tmp = bin(00001100); break;
  case 4:   tmp = bin(10011000); break;
  case 5:   tmp = bin(01001000); break;
  case 6:   tmp = bin(01000000); break;
  case 7:   tmp = bin(00011110); break;
  case 8:   tmp = bin(00000000); break;
  case 9:   tmp = bin(00001000); break;

  case 10:  tmp = bin(01111110); break;
  case 11:  tmp = bin(10111110); break;
  case 12:  tmp = bin(11011110); break;
  case 13:  tmp = bin(11101110); break;
  case 14:  tmp = bin(11110110); break;
  case 15:  tmp = bin(11111010); break;
  case 16:  tmp = bin(11111100); break;

  case 17:  tmp = bin(11101100); break;
  case 18:  tmp = bin(01101100); break;

  case ' ': tmp = bin(11111110); break;
  case 'v':
  case 'u': tmp = bin(11000110); break;
  case 'c': tmp = bin(11100100); break;
  case 'b': tmp = bin(11000000); break;
  case 't': tmp = bin(11100000); break;
  case 'l': tmp = bin(11100110); break;
  case 'o': tmp = bin(11000100); break;
  case 'A': tmp = bin(00010000); break;
  case 'H': tmp = bin(10010000); break;
  case 'C': tmp = bin(01100010); break;
  case 'P': tmp = bin(00110000); break;
  case 'E': tmp = bin(01100000); break;
  case 'U': tmp = bin(10000010); break;
  case 'f':
  case 'F': tmp = bin(01110000); break;
  case 'L': tmp = bin(11100010); break;
  case 'r': tmp = bin(11110100); break;
  case 'd': tmp = bin(10000100); break;
  case 'n': tmp = bin(11010100); break;
  case 'G': tmp = bin(01000010); break;
  case 'N': tmp = bin(00010010); break;
  case 'O': tmp = bin(00000010); break;
  case 'i': tmp = bin(11110110); break;
  case 'I': tmp = bin(11110010); break;
  case 'S': tmp = bin(01001000); break;
  case 'J': tmp = bin(10001110); break;
  case 'h': tmp = bin(11010000); break;
  case '_': tmp = bin(11101110); break;
  default:  tmp = bin(11111100); break; //-
 }

 //     
 if(dpp[pc]==false) tmp |= 1;

 //      
 if(ssg_pl==c_cathode)tmp = ~tmp;

 // 
 pt2 = seg_wire;

 for(s8 i=7;i>=0;i--)
 {
  kl = (u8)pt2->GPIO_Pin;

  if(tmp&(1<<i)) pt2->GPIOx->ODR |= kl;
  else           pt2->GPIOx->ODR &= ~kl;

  pt2++;
 }

 //     
 pt = com_wire+pc;

 for(u8 k=0;k<CW_NUM;k++)
 {
  pt2 = pt->wire + k;

  kl = (u8)pt2->GPIO_Pin;

  //        
  if(ssg_pl==c_cathode)pt2->GPIOx->ODR &= ~kl;
  //      
  else
  {
   pt2->GPIOx->ODR |= kl;
   pt2->GPIOx->CR1 |= kl;
  }

  //  
  pt2->GPIOx->DDR |= kl;
 }
}

void detect_7seg_polarity(SPL *ssg_pl)
{
 u8 kl;

 //     
 for(u8 i=0;i<SEG_NUM;i++)
 {
  GDF *pt = seg_wire+i;
  kl = (u8)pt->GPIO_Pin;

  //  
  pt->GPIOx->DDR |= kl;
  //   
  pt->GPIOx->ODR &= ~kl;
 }

 GDF *pt2;
 //         
 for(u8 i=0;i<DNUM;i++)
 {
  CW_GDF *pt = com_wire+i;

  for(u8 k=0;k<CW_NUM;k++)
  {
   pt2 = pt->wire + k;

   kl = (u8)pt2->GPIO_Pin;

   //  
   pt2->GPIOx->DDR &= ~kl;
   //   
   pt2->GPIOx->CR1 |= kl;
  }
 }

 u8 n=0;
 //      
 for(u8 i=0x0f;i;i--)
 {
  if(pt2->GPIOx->IDR & kl)n++;
  else if(n)n--;
 }
 //    ,     
  if(n>0x0f/2)*ssg_pl = c_cathode;
 //          
  else        *ssg_pl = c_anode;

#ifdef debug
  *ssg_pl = c_anode;
#endif
}

void convert_data (u16 d, u8 dbuf[], u8 dnum = DNUM)
{
 for (u8 k=0;k<dnum;k++)
  {
   dbuf[k]=d%10;
   d/=10;
  }
}

void init_dpins(GDF seg_wire[], CW_GDF com_wire[])
{
 u8 kl;

 for(u8 i=0;i<SEG_NUM;i++)
 {
  GDF *pt = seg_wire+i;
  kl = (u8)pt->GPIO_Pin;

  pt->GPIOx->DDR |= kl;
  pt->GPIOx->CR1 |= kl;
  pt->GPIOx->ODR |= kl;
 }

 for(u8 i=0;i<DNUM;i++)
 {
  CW_GDF *pt = com_wire+i;

  for(u8 k=0;k<CW_NUM;k++)
  {
   GDF *pt2 = pt->wire + k;

   kl = (u8)pt2->GPIO_Pin;

   pt2->GPIOx->DDR |= kl;
   pt2->GPIOx->CR1 |= kl;
   pt2->GPIOx->ODR |= kl;
  }
 }
}

void inwork_animation(u8 *dbuf, bool cond = false)
{
 static u8 stage;
 static u8 tmp_dbuf = ' ';
 static bool tmp_trg=0;

 //    
 if(tmp_trg && cond==false)
 {
  stage = 0;

  *dbuf = tmp_dbuf;
  tmp_trg = 0;
 }
 //     
 else if(!tmp_trg && cond==true)
 {
  tmp_trg = 1;
  tmp_dbuf = *dbuf;
 }

 if(cond==true)
 {
  stage<3?stage++:stage=0;

  //    
  switch(stage)
  {
   case 0: *dbuf = '_'; break;
   case 1: *dbuf = 17; break;
   case 2: *dbuf = 18; break;
   default: break;
  }
 }
}

void ttd(u8 *dbuf, u32 t_val)
{
 u16 tmp = t_val/60/1000;

 convert_data (tmp, dbuf, 2);
}